## irony-mode 0.1.2

=== server/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3) # CMAKE_CURRENT_LIST_DIR

project(IronyMode)

set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/modules
  ${CMAKE_MODULE_PATH})

include(utils)

check_for_in_source_build()
release_as_default_build_type()

# Disable exception, we aren't using them and right now clang-cl needs them
# disabled to parse Windows headers.
#
# Logic stolen from LLVM
if (CMAKE_COMPILER_IS_GNUCXX)
  set(IRONY_COMPILER_IS_GCC_COMPATIBLE ON)
elseif (MSVC)
  set(IRONY_COMPILER_IS_GCC_COMPATIBLE OFF)
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(IRONY_COMPILER_IS_GCC_COMPATIBLE ON)
endif()
	
if(IRONY_COMPILER_IS_GCC_COMPATIBLE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
elseif(MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHs-c- /D_HAS_EXCEPTIONS=0")
  # irony-server uses some code that breaks when iterator debugging is enabled
  #
  # The culprit is CommandLineArgumentParser who initialize its member
  # 'Position', of type 'std::string::const_iterator', to 'Input.begin() - 1'.
  # With checked iterator the begin() - 1 breaks in debug build.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /D_ITERATOR_DEBUG_LEVEL=0")
endif()

enable_colored_diagnotics()
check_cxx11_options()

if (CXX11_COMPILE_OPTIONS)
  add_compile_options_(${CXX11_COMPILE_OPTIONS})
endif()

foreach (link_option ${CXX11_LINK_OPTIONS})
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${link_option}")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${link_option}")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${link_option}")
endforeach()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
  add_compile_options_(-Wall -Wextra)
endif()

option(GENERATE_DOXYGEN "Whether or not to build the Doxygen documentation" OFF)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

add_subdirectory(src)
add_subdirectory(docs)
enable_testing()
add_subdirectory(test)

=== server/src/CMakeLists.txt ===
include(CheckLibClangBuiltinHeadersDir)

find_package(LibClang REQUIRED)

include_directories(${LIBCLANG_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

check_libclang_builtin_headers_dir()

if (LIBCLANG_BUILTIN_HEADERS_DIR)
  # look for CLANG_BUILTIN_HEADERS_DIR usage in the code for an explanation
  add_definitions(-DCLANG_BUILTIN_HEADERS_DIR=\"${LIBCLANG_BUILTIN_HEADERS_DIR}\")
endif()

# not to be taken as a module-definition file to link on Windows
set_source_files_properties(Commands.def PROPERTIES HEADER_FILE_ONLY TRUE)

add_executable(irony-server
  support/arraysize.h
  support/CommandLineParser.cpp
  support/CommandLineParser.h
  support/iomanip_quoted.h
  support/NonCopyable.h
  support/TemporaryFile.cpp
  support/TemporaryFile.h

  Command.cpp
  Commands.def
  Command.h
  Irony.cpp
  Irony.h
  TUManager.cpp
  TUManager.h

  main.cpp)

# retrieve the package version from irony.el
function(irony_find_package_version OUTPUT_VAR)
  # this is a hack that force CMake to reconfigure, it is necessary to see if
  # the version in irony.el has changed, this is not possible to add the
  # definitions at build time
  configure_file(${PROJECT_SOURCE_DIR}/../irony.el
    ${CMAKE_CURRENT_BINARY_DIR}/irony.el
    COPYONLY)

  set(version_header "\;\; Version: ")
  file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/irony.el version
    LIMIT_COUNT 1
    REGEX "^${version_header}*")

  if (NOT version)
    message (FATAL_ERROR "couldn't find irony.el's version header!")
  endif()

  string(LENGTH ${version_header} version_header_length)
  string(SUBSTRING ${version} ${version_header_length} -1 package_version)
  set(${OUTPUT_VAR} ${package_version} PARENT_SCOPE)
endfunction()

irony_find_package_version(IRONY_PACKAGE_VERSION)
message(STATUS "Irony package version is '${IRONY_PACKAGE_VERSION}'")

set_source_files_properties(main.cpp
  PROPERTIES
  COMPILE_DEFINITIONS IRONY_PACKAGE_VERSION=\"${IRONY_PACKAGE_VERSION}\")

target_link_libraries(irony-server ${LIBCLANG_LIBRARIES})

install(TARGETS irony-server DESTINATION bin)

=== server/test/CMakeLists.txt ===
add_subdirectory (elisp)

=== server/test/elisp/CMakeLists.txt ===
# On MS-Windows, emacs_dir is a special environment variable, which
# indicates the full path of the directory in which Emacs is
# installed.
#
# There is no standard location that I know of for Emacs on Windows so
# using this special environment variable will at least help people
# who build the server from inside Emacs.
if(DEFINED ENV{emacs_dir})
  list(APPEND EMACS_EXECUTABLE_HINTS $ENV{emacs_dir}/bin)
endif()

find_program(EMACS_EXECUTABLE emacs
  HINTS ${EMACS_EXECUTABLE_HINTS})

if (EMACS_EXECUTABLE)
  message(STATUS "Found emacs: ${EMACS_EXECUTABLE}")
else()
  message(WARNING "emacs not found: elisp tests will be skipped!")
  return()
endif()

#
# ert_test(name test_file)
#
# creates a test target named NAME which run the Elisp script TEST_FILE using
# the Emacs ERT testing framework.
#
# FIXME: assumes MELPA is configured...
function(ert_test name test_file)
  add_test(${name}
    ${EMACS_EXECUTABLE} -batch
    -l package
    --eval "(package-initialize) (unless (require 'cl-lib nil t) (package-refresh-contents) (package-install 'cl-lib))"
    -l ${CMAKE_CURRENT_SOURCE_DIR}/${test_file}
    -f ert-run-tests-batch-and-exit)
endfunction()

ert_test(irony-el irony.el)
ert_test(irony-cdb-el irony-cdb.el)

=== debian/changelog ===
irony-mode (0.1.2-1) unstable; urgency=medium

  * New upstream version
  * Add VCS

 -- Christoph Egger <christoph@debian.org>  Sat, 03 Jan 2015 18:16:58 +0100

irony-mode (0.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #741024)

 -- Christoph Egger <christoph@debian.org>  Thu, 23 Oct 2014 14:29:43 +0200

=== debian/control ===
Source: irony-mode
Section: x11
Priority: optional
Maintainer: Christoph Egger <christoph@debian.org>
Build-Depends:
 debhelper (>> 9~),
 cmake,
 libclang-dev
Standards-Version: 3.9.6
Homepage: https://github.com/Sarcasm/irony-mode/
Vcs-Git: git://git.debian.org/collab-maint/irony-mode.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/herbstluftwmirony-mode.git;a=summary

Package: irony-mode
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 emacsen-common (>= 2.0.8)
Description: C/C++ minor mode powered by libclang
 irony-mode is an Emacs minor-mode that aims at improving the editing
 experience for the C, C++ and Objective-C languages. It works by
 using a combination of an Emacs package and a C++ program
 (irony-server) that uses libclang.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Dserver --parallel

## irony-mode 0.2.0

=== server/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,8 @@
   ${CMAKE_MODULE_PATH})
 
 include(utils)
+
+include(CTest)
 
 check_for_in_source_build()
 release_as_default_build_type()
@@ -61,5 +63,7 @@
 
 add_subdirectory(src)
 add_subdirectory(docs)
-enable_testing()
-add_subdirectory(test)
+
+if (BUILD_TESTING)
+  add_subdirectory(test)
+endif()

=== server/docs/CMakeLists.txt ===
if (GENERATE_DOXYGEN)
  find_package (Doxygen REQUIRED)

  set (HAS_DOT_VALUE "NO")
  if (DOXYGEN_DOT_FOUND)
    set (HAS_DOT_VALUE "YES")
  endif()

  configure_file(irony-server.cfg.in irony-server.cfg @ONLY)

  add_custom_target(doxygen
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/irony-server.cfg
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif()

=== server/src/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
   support/CommandLineParser.h
   support/iomanip_quoted.h
   support/NonCopyable.h
+  support/CIndex.h
   support/TemporaryFile.cpp
   support/TemporaryFile.h

=== server/test/elisp/CMakeLists.txt ===
--- 
+++ 
@@ -20,14 +20,18 @@
 endif()
 
 #
-# ert_test(name test_file)
+# add_ert_test(<FileName>)
 #
-# creates a test target named NAME which run the Elisp script TEST_FILE using
-# the Emacs ERT testing framework.
+# Create a test which run the given Elisp script using the Emacs ERT testing
+# framework.
+#
+# The target is deduced from the ``FileName`` argument, e.g: the file foo.el
+# will be the target 'check-foo-el'.
 #
 # FIXME: assumes MELPA is configured...
-function(ert_test name test_file)
-  add_test(${name}
+function(add_ert_test test_file)
+  get_filename_component(name ${test_file} NAME_WE)
+  add_test(check-${name}-el
     ${EMACS_EXECUTABLE} -batch
     -l package
     --eval "(package-initialize) (unless (require 'cl-lib nil t) (package-refresh-contents) (package-install 'cl-lib))"
@@ -35,5 +39,5 @@
     -f ert-run-tests-batch-and-exit)
 endfunction()
 
-ert_test(irony-el irony.el)
-ert_test(irony-cdb-el irony-cdb.el)
+add_ert_test(irony.el)
+add_ert_test(irony-cdb-json.el)

=== debian/changelog ===
irony-mode (0.2.0-1) unstable; urgency=medium

  * Team upload (collab-maint).
  * New upstream release.
  * Add watch file.
  * Drop llvm patch, upstream.
  * Make VCS fields in secure mode.
  * bump std-version to 3.9.8, no changes required.

  [ Tim Marston ]
  * Fix bad package autoload (Closes: #824855)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Oct 2016 10:14:16 +0200

irony-mode (0.1.2-2) unstable; urgency=medium

  * Update against newer libclang (Closes: #803650)
  * Update VCS-Browser (Closes: #803649)

 -- Christoph Egger <christoph@debian.org>  Tue, 15 Mar 2016 13:46:05 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
  debhelper (>> 9~),
  cmake,
  libclang-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/Sarcasm/irony-mode/
-Vcs-Git: git://git.debian.org/collab-maint/irony-mode.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/herbstluftwmirony-mode.git;a=summary
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/irony-mode.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/irony-mode.git
 
 Package: irony-mode
 Architecture: any

## irony-mode 0.2.1

=== server/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   set(IRONY_COMPILER_IS_GCC_COMPATIBLE ON)
 endif()
-	
+
 if(IRONY_COMPILER_IS_GCC_COMPATIBLE)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
 elseif(MSVC)

=== server/src/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,6 @@
 set_source_files_properties(Commands.def PROPERTIES HEADER_FILE_ONLY TRUE)
 
 add_executable(irony-server
-  support/arraysize.h
   support/CommandLineParser.cpp
   support/CommandLineParser.h
   support/iomanip_quoted.h

=== server/test/elisp/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,8 @@
   add_test(check-${name}-el
     ${EMACS_EXECUTABLE} -batch
     -l package
-    --eval "(package-initialize) (unless (require 'cl-lib nil t) (package-refresh-contents) (package-install 'cl-lib))"
+    --eval "(package-initialize)"
+    --eval "(unless (require 'cl-lib nil t) (package-refresh-contents) (package-install 'cl-lib))"
     -l ${CMAKE_CURRENT_SOURCE_DIR}/${test_file}
     -f ert-run-tests-batch-and-exit)
 endfunction()

=== debian/changelog ===
irony-mode (0.2.1-1~exp1build1) artful; urgency=medium

  * Rebuild against new llvm versioned symbols.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 01 May 2017 22:34:38 +0200

irony-mode (0.2.1-1~exp1) experimental; urgency=medium

  * Team upload (collab-maint).
  * New upstream release
    - compatible with llvm 4.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Apr 2017 13:47:43 +0200

## irony-mode 1.2.0

=== server/CMakeLists.txt ===
--- 
+++ 
@@ -51,8 +51,15 @@
   set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${link_option}")
 endforeach()
 
+# Turn this on for local development or continuous integration
+option(IRONY_WARNINGS_AS_ERRORS "Whether or not to treat warnings as errors" OFF)
+
 if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
   add_compile_options_(-Wall -Wextra)
+
+  if (IRONY_WARNINGS_AS_ERRORS)
+    add_compile_options_(-Werror)
+  endif()
 endif()
 
 option(GENERATE_DOXYGEN "Whether or not to build the Doxygen documentation" OFF)

=== server/test/CMakeLists.txt ===
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure)

add_subdirectory (elisp)

=== debian/changelog ===
irony-mode (1.2.0-4) unstable; urgency=medium

  * Drop ert-helper.el.
  * Import upstream fix for failing ert test in autopkgtest:
    - Fixes "FAILED  31/41  irony/find-server-executable/does-not-exists"
  * Switch to debhelper 11.
  * Declare compat level 11.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Sun, 07 Jan 2018 18:39:00 -0500

irony-mode (1.2.0-3) unstable; urgency=medium

  * Switch to libclang-5.0-dev, now that Bug #881663 has been resolved.
  * Customise elpa-test to work around autopkgtest error.
  * Declare Standards-Version: 4.1.3. (No additional changes needed)

 -- Nicholas D Steeves <nsteeves@gmail.com>  Thu, 28 Dec 2017 16:30:05 -0500

irony-mode (1.2.0-2) unstable; urgency=medium

  * debian/control: Add Breaks and Replaces (<< 1.2.0-1) to allow clean
    upgrades. (Closes: #880900)
  * Import upstream commit to make tests pass more reliably.
    - Adds 02-irony-iotask-fix-spurious-failure-of-invalid-msg-test.patch
  * Rename fix-install-prefix to 01-fix-install-prefix.patch
  * Allow linking with either libclang-4.0-dev | libclang-5.0-dev
    Rational: libclang-5.0-dev isn't yet in a good state for
    mipsel or mips64el.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Tue, 14 Nov 2017 17:08:27 -0500

irony-mode (1.2.0-1) unstable; urgency=medium

  * Package is now maintained by Debian Emacs addons team:
    - debian/control: Change maintainer to Debian Emacs addons team.
    - debian/control: Add primary maintainer (Christoph Egger) to Uploaders,
      and add myself.
    - debian/control: Update VCS links to use new pkg-emacsen location
      rather than collab-maint.
  * New upstream version.
  * Elpafy irony-mode. (Closes: #872689):
    - debian/rules: Add --with elpa.
    - debian/control: Add dh-elpa to Build-Depends.
    - debian/control: Split package into Arch: all elpa-irony and Arch: any
      irony-server.
    - debian/control: irony-mode is now a dummy transitional package.
    - debian/control: Require debhelper >= 10.
    - debian/compat: Require compat level 10.
    - debian/rules: Drop --parallel, because it's implicit with dh 10.
    - debian/control: Change section from x11 to lisp.
    - Drop obsolete emacsen-compat, emacsen-install, emacsen-remove,
      emacsen-startup, and install.
    - Instruct dh-elpa to bytecompile and install *.el using elpa-irony.elpa.
    - Install irony-server using irony-server.install.
    - Add Testsuite: autopkgtest-pkg-elpa.
  * debian/control:
    - Declare Standards-Version: 4.1.1. (No additional changes needed)
    - Update libclang-dev Build-Depends to use libclang-5.0-dev.
      (Closes: #873410)
    - Update short description to say this is an Emacs package.
    - Add elpa-yasnippet to Suggests.
  * Generate and install man page:
    - debian/control: Add python3-docutils to Build-Depends.
    - debian/rules: Add override_dh_installman.
    - Create debian/irony-server.manpages.
  * Add DEP-3 header to debian/patches/fix-install-prefix.
  * debian/copyright:
    - Update copyright for irony-mode from L3 of irony.el.
    - Add missing copyright for irony-cdb-libclang.el
      and server/build-aux/run-clang-tidy/run-clang-tidy.py.
    - Add myself to debian/* section.
    - Add copyright-format/1.0 header.
    - Add correct paragraph separators.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Wed, 25 Oct 2017 13:49:39 -0400

=== debian/control ===
Source: irony-mode
Section: lisp
Priority: optional
Maintainer: Debian Emacs addons team <pkg-emacsen-addons@lists.alioth.debian.org>
Uploaders: Christoph Egger <christoph@debian.org>,
 Nicholas D Steeves <nsteeves@gmail.com>
Build-Depends:
 debhelper (>= 11),
 cmake,
 libclang-5.0-dev,
 dh-elpa,
 python3-docutils
Standards-Version: 4.1.3
Homepage: https://github.com/Sarcasm/irony-mode/
Vcs-Git: https://anonscm.debian.org/git/pkg-emacsen/pkg/irony-mode.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-emacsen/pkg/irony-mode.git
Testsuite: autopkgtest-pkg-elpa

Package: elpa-irony
Architecture: all
Depends:
 ${elpa:Depends},
 ${misc:Depends},
 irony-server
Suggests: elpa-yasnippet
Description: Emacs C/C++ minor mode powered by libclang
 irony-mode is an Emacs minor-mode that aims at improving the editing
 experience for the C, C++ and Objective-C languages. It works by
 using a combination of an Emacs package and a C++ program
 (irony-server) that uses libclang.
 .
 This package contains irony-mode.

Package: irony-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: irony-mode (<< 1.2.0-1)
Replaces: irony-mode (<< 1.2.0-1)
Description: Emacs C/C++ minor mode powered by libclang (server)
 irony-mode is an Emacs minor-mode that aims at improving the editing
 experience for the C, C++ and Objective-C languages. It works by
 using a combination of an Emacs package and a C++ program
 (irony-server) that uses libclang.
 .
 This package contains the architecture-specific irony-server.

Package: irony-mode
Architecture: all
Depends: ${misc:Depends}, elpa-irony
Description: Transition Package, irony-mode to elpa-irony
 The irony-mode addon has been elpafied. This dummy package
 helps ease the transition from irony-mode to elpa-irony
 and is safe to remove.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Dserver --with elpa

override_dh_installman:
	mkdir -p debian/tmp
	rst2man irony-server.rst > debian/tmp/irony-server.man
	dh_installman

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/irony-mode-$1\.tar\.gz/ \
  https://github.com/Sarcasm/irony-mode/tags .*/v?(\d\S+)\.tar\.gz

## irony-mode 1.3.1

=== server/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
-include(CheckLibClangBuiltinHeadersDir)
+include(CheckClangResourceDir)
 
 find_package(LibClang REQUIRED)
 
 include_directories(${LIBCLANG_INCLUDE_DIRS})
 include_directories(${CMAKE_CURRENT_SOURCE_DIR})
 
-check_libclang_builtin_headers_dir()
+check_clang_resource_dir()
 
-if (LIBCLANG_BUILTIN_HEADERS_DIR)
+if (CLANG_RESOURCE_DIR)
   # look for CLANG_BUILTIN_HEADERS_DIR usage in the code for an explanation
-  add_definitions(-DCLANG_BUILTIN_HEADERS_DIR=\"${LIBCLANG_BUILTIN_HEADERS_DIR}\")
+  add_definitions(-DCLANG_RESOURCE_DIR=\"${CLANG_RESOURCE_DIR}\")
 endif()
 
 # not to be taken as a module-definition file to link on Windows

=== debian/changelog ===
irony-mode (1.3.1-3) unstable; urgency=medium

  [ Nicholas D Steeves ]
  * Switch to debhelper-compat 12.
  * Build against libclang-8.

  [ David Bremner ]
  * Team upload
  * Rebuild with quilt patches

 -- David Bremner <bremner@debian.org>  Sun, 25 Aug 2019 16:53:31 -0300

irony-mode (1.3.1-2) unstable; urgency=medium

  * Team upload.
  * Rebuild with current dh-elpa

 -- David Bremner <bremner@debian.org>  Sun, 25 Aug 2019 10:25:58 -0300

irony-mode (1.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop all patches that are part of this upstream release:
    - 02-irony-iotask-fix-spurious-failure-of-invalid-msg-test.patch
    - 03-fix-irony.el-does-not-exists-test-when-irony-server-.patch
  * Build against libclang-7 rather than 6.0. (Closes: #912801)
  * Update the copyright years range for myself.
  * debian/control: Add "Enhances: emacs".
  * Declare Standards-Version: 4.3.0. (No changes needed)

 -- Nicholas D Steeves <nsteeves@gmail.com>  Sun, 23 Dec 2018 19:58:29 -0700

irony-mode (1.2.0-6) unstable; urgency=medium

  * debian/elpa-test: (require 'cl), for autopkgtests.  This was not
    needed in the past when running autopkgtests in an LXC, and is still
    not needed when building locally, in an LXC or any type of chroot.  It
    is unclear why DebCI requires this now (post unversioned emacs and
    post emacsen-common 3.0.2).
  * Declare Standards-Version: 4.2.0. (No additional changes needed)
  * Enable hardening=+all dpkg-buildflags.  Possibly paranoia, but we live
    in the age of Spectre, and it might be possible for evil code to break
    out via irony-server.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Sat, 11 Aug 2018 21:04:25 -0400

irony-mode (1.2.0-5) unstable; urgency=medium

  * Install upstream README.md
  * Change section to editors, which is more accurate and discoverable.
    - irony-mode is an interactive minor mode and not just a lisp library.
  * Relax debhelper dependency to allow backporting.
  * Switch Vcs from alioth to salsa.
  * Update Maintainer team name and email address.
  * Set dummy transitional package "irony-mode" to "Section: oldlibs".
  * Build against libclang-6.0 rather than 5.0. (Closes: #904277)
  * Declare Standards-Version: 4.1.5. (No additional changes needed)

 -- Nicholas D Steeves <nsteeves@gmail.com>  Sun, 22 Jul 2018 16:55:16 -0400

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: irony-mode
-Section: lisp
+Section: editors
 Priority: optional
-Maintainer: Debian Emacs addons team <pkg-emacsen-addons@lists.alioth.debian.org>
+Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
 Uploaders: Christoph Egger <christoph@debian.org>,
  Nicholas D Steeves <nsteeves@gmail.com>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
  cmake,
- libclang-5.0-dev,
+ libclang-8-dev,
  dh-elpa,
  python3-docutils
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Homepage: https://github.com/Sarcasm/irony-mode/
-Vcs-Git: https://anonscm.debian.org/git/pkg-emacsen/pkg/irony-mode.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-emacsen/pkg/irony-mode.git
+Vcs-Git: https://salsa.debian.org/emacsen-team/irony-mode.git
+Vcs-Browser: https://salsa.debian.org/emacsen-team/irony-mode
 Testsuite: autopkgtest-pkg-elpa
 
 Package: elpa-irony
@@ -23,6 +23,7 @@
  ${misc:Depends},
  irony-server
 Suggests: elpa-yasnippet
+Enhances: emacs
 Description: Emacs C/C++ minor mode powered by libclang
  irony-mode is an Emacs minor-mode that aims at improving the editing
  experience for the C, C++ and Objective-C languages. It works by
@@ -49,6 +50,7 @@
 Package: irony-mode
 Architecture: all
 Depends: ${misc:Depends}, elpa-irony
+Section: oldlibs
 Description: Transition Package, irony-mode to elpa-irony
  The irony-mode addon has been elpafied. This dummy package
  helps ease the transition from irony-mode to elpa-irony

## irony-mode 1.4.0

=== server/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)

project(IronyMode)

set(CMAKE_MODULE_PATH
  ${PROJECT_SOURCE_DIR}/cmake
  ${PROJECT_SOURCE_DIR}/cmake/modules
  ${CMAKE_MODULE_PATH})

include(CTest)
include(GNUInstallDirs)

# Starting from CMake >= 3.1, if a specific standard is required,
# it can be set from the command line with:
#     cmake -DCMAKE_CXX_STANDARD=[11|14|17]
function(irony_target_set_cxx_standard target)
  set(cxx_standard 11)
  if (CMAKE_VERSION VERSION_LESS "3.1")
    if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
      target_compile_options(${target} PRIVATE -std=c++${cxx_standard})
    endif()
  elseif (CMAKE_VERSION VERSION_LESS "3.8")
    set_property(TARGET ${target} PROPERTY CXX_STANDARD ${cxx_standard})
  else()
    target_compile_features(${target} PUBLIC cxx_std_${cxx_standard})
  endif()
endfunction()

add_subdirectory(src)

if (BUILD_TESTING)
  add_subdirectory(test)
endif()

=== debian/changelog ===
irony-mode (1.4.0-2) unstable; urgency=medium

  * Drop transitional dummy package "irony-mode".
  * Add Breaks and Replaces against less than this version.
  * Elpa-irony-mode now Provides irony-mode.
  * Drop Christoph Egger from Uploaders; He has not worked on this
    package since 2016 and did not follow up on a 27 Sep 2019 email that
    requested confirmation of continued interest.
  * Add 0002-README-Add-section-about-how-to-access-newer-version.patch
    This patch adds a section documenting how backports are the
    recommended mechanism to get newer versions of Clang and irony-mode,
    and it also provides a link to Sylvestre Ledru's unofficial LLVM
    nightly repository.  While the latter method is not officially
    supported, I agree with Sylvestre that it is a valuable service to
    users who might want to live on the edge in this one aspect.  Upstream
    agrees, and in conclusion it's good for the irony-mode community.
  * Build against libclang-10.
  * Add clang-10 and llvm-10-dev to build-deps; compilation fails without
    these with the following errors: 'Could NOT find LibClang (missing:
    LIBCLANG_LIBRARY LIBCLANG_INCLUDE_DIR)' and 'Could not find a package
    configuration file provided by "LLVM" with any of the following names:
    LLVMConfig.cmake llvm-config.cmake'.
  * control: Add "Rules-Requires-Root: no".

 -- Nicholas D Steeves <nsteeves@gmail.com>  Sat, 28 Mar 2020 18:42:12 -0400

irony-mode (1.4.0-1) unstable; urgency=medium

  * Build against libclang-9.
  * Declare Standards-Version 4.4.1. (no changes required)

 -- Nicholas D Steeves <nsteeves@gmail.com>  Wed, 09 Oct 2019 19:04:49 -0400

=== debian/control ===
Source: irony-mode
Section: editors
Priority: optional
Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
Uploaders: Nicholas D Steeves <nsteeves@gmail.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libclang-10-dev,
 clang-10,
 llvm-10-dev,
 dh-elpa,
 python3-docutils
Rules-Requires-Root: no
Standards-Version: 4.4.1
Homepage: https://github.com/Sarcasm/irony-mode/
Vcs-Git: https://salsa.debian.org/emacsen-team/irony-mode.git
Vcs-Browser: https://salsa.debian.org/emacsen-team/irony-mode
Testsuite: autopkgtest-pkg-elpa

Package: elpa-irony
Architecture: all
Depends:
 ${elpa:Depends},
 ${misc:Depends},
 irony-server
Breaks: irony-mode (<< 1.4.0-2~)
Replaces: irony-mode (<< 1.4.0-2~)
Provides: irony-mode
Suggests: elpa-yasnippet
Enhances: emacs
Description: Emacs C/C++ minor mode powered by libclang
 irony-mode is an Emacs minor-mode that aims at improving the editing
 experience for the C, C++ and Objective-C languages. It works by
 using a combination of an Emacs package and a C++ program
 (irony-server) that uses libclang.
 .
 This package contains irony-mode.

Package: irony-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Emacs C/C++ minor mode powered by libclang (server)
 irony-mode is an Emacs minor-mode that aims at improving the editing
 experience for the C, C++ and Objective-C languages. It works by
 using a combination of an Emacs package and a C++ program
 (irony-server) that uses libclang.
 .
 This package contains the architecture-specific irony-server.

## irony-mode 1.4.0%2B7.g76fd37f

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,15 @@
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
 Uploaders: Nicholas D Steeves <nsteeves@gmail.com>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  cmake,
- libclang-10-dev,
- clang-10,
- llvm-10-dev,
+ libclang-11-dev,
+ clang-11,
+ llvm-11-dev,
  dh-elpa,
  python3-docutils
 Rules-Requires-Root: no
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/Sarcasm/irony-mode/
 Vcs-Git: https://salsa.debian.org/emacsen-team/irony-mode.git
 Vcs-Browser: https://salsa.debian.org/emacsen-team/irony-mode

## irony-mode 1.4.0+7.g76fd37f

=== server/test/elisp/CMakeLists.txt ===
--- 
+++ 
@@ -32,13 +32,16 @@
 function(add_ert_test test_file)
   get_filename_component(name ${test_file} NAME_WE)
   add_test(check-${name}-el
-    ${EMACS_EXECUTABLE} -batch
+    ${EMACS_EXECUTABLE} -Q --batch
     -l package
     --eval "(package-initialize)"
     --eval "(unless (require 'cl-lib nil t) (package-refresh-contents) (package-install 'cl-lib))"
     -l ${CMAKE_CURRENT_SOURCE_DIR}/${test_file}
     -f ert-run-tests-batch-and-exit)
+
+  set_tests_properties(check-${name}-el PROPERTIES TIMEOUT 15)
 endfunction()
 
 add_ert_test(irony.el)
+add_ert_test(irony-iotask.el)
 add_ert_test(irony-cdb-json.el)

=== debian/changelog ===
irony-mode (1.4.0+7.g76fd37f-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Nicholas D Steeves <sten@debian.org>  Thu, 05 Aug 2021 22:01:24 -0400

irony-mode (1.4.0+7.g76fd37f-1) unstable; urgency=medium

  * New upstream snapshot.
  * Rebase patches onto 1.4.0+7.g76fd37f.
  * Drop 0002-README-Add-section-about-how-to-access-newer-version.patch
    (merged upstream).
  * Switch to llvm-toolchain-11, and build with libclang-11-dev, clang-11,
    and llvm-11-dev (Closes: #974780).
  * Migrate to debhelper-compat 13.
  * Declare Standards-Version 4.5.0 (no changes required).

 -- Nicholas D Steeves <nsteeves@gmail.com>  Sat, 14 Nov 2020 18:27:09 -0500

irony-mode (1.3.1-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Nicholas D Steeves <nsteeves@gmail.com>  Mon, 09 Sep 2019 07:58:00 -0400

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@ -Dserver --with elpa

## irony-mode 1.5.0

=== debian/changelog ===
irony-mode (1.5.0-2) unstable; urgency=medium

  * Switch to llvm-toolchain-13, and build with libclang-13-dev, clang-13,
    and llvm-13-dev.
  * rules: Add override_dh_elpa, use sed to set $DEB_VERSION_UPSTREAM
    everywhere where the dummy version "1.2.0" appears in upstream source,
    and then cleanup; this resolves potential confusion about which version
    the Debian package contains.
  * Declare Standards-Version 4.6.0.1 (no changes required).

 -- Nicholas D Steeves <sten@debian.org>  Fri, 10 Dec 2021 12:22:01 -0500

irony-mode (1.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Update my email address.
  * Switch to llvm-toolchain-12, and build with libclang-12-dev, clang-12,
    and llvm-12-dev.
  * Switch to watch file v4 (no further changes required).

 -- Nicholas D Steeves <sten@debian.org>  Wed, 15 Sep 2021 16:56:37 -0400

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,17 @@
 Section: editors
 Priority: optional
 Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
-Uploaders: Nicholas D Steeves <nsteeves@gmail.com>
+Uploaders: Nicholas D Steeves <sten@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- libclang-11-dev,
- clang-11,
- llvm-11-dev,
+ libclang-13-dev,
+ clang-13,
+ llvm-13-dev,
  dh-elpa,
  python3-docutils
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 Homepage: https://github.com/Sarcasm/irony-mode/
 Vcs-Git: https://salsa.debian.org/emacsen-team/irony-mode.git
 Vcs-Browser: https://salsa.debian.org/emacsen-team/irony-mode

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/irony-mode-$1\.tar\.gz/ \
  https://github.com/Sarcasm/irony-mode/tags .*/v?(\d\S+)\.tar\.gz

## irony-mode 1.6.0

=== server/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0.2)
+cmake_minimum_required(VERSION 3.0.2...3.27)
 
 project(IronyMode)

=== debian/changelog ===
irony-mode (1.6.0-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:56:33 +1100

irony-mode (1.6.0-2build1) noble; urgency=medium

  * No-change rebuild against libllvm16 t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 20:21:53 +0100

irony-mode (1.6.0-2) unstable; urgency=medium

  * Switch to llvm-toolchain-16, and build with libclang-16-dev, clang-16,
    and llvm-16-dev.

 -- Nicholas D Steeves <sten@debian.org>  Tue, 24 Oct 2023 16:53:14 -0400

irony-mode (1.6.0-1) unstable; urgency=medium

  * New upstream release (Closes: #1052955).
  * Rebase quilt series onto this release.

 -- Nicholas D Steeves <sten@debian.org>  Thu, 28 Sep 2023 13:58:25 -0400

irony-mode (1.5.0-5+deb12u1) bookworm; urgency=medium

  * Rebuild with llvm-toolchain-15 1:15.0.6-4, because the timing of the last
    upload resulted in a bin:irony-server runtime dependency on libclang1-15
    (>= 1:15.0.7-1), but llvm-toolchain-15 1:15.0.7-1 will not migrate to
    testing/bookworm (see #1032899 and #1032887).  A rebuild with 1:15.0.6-4
    is the only good solution for providing bookworm users with an irony-mode
    package built with a sufficiently recent libclang (15, not 14).  Upstream
    LLVM released version 16 on 2023-03-18, during bookworm's hard-freeze, so
    using it was never an option.

 -- Nicholas D Steeves <sten@debian.org>  Wed, 26 Apr 2023 15:07:44 -0400

irony-mode (1.5.0-5) unstable; urgency=medium

  * Switch to llvm-toolchain-15, and build with libclang-15-dev, clang-15,
    and llvm-15-dev.

 -- Nicholas D Steeves <sten@debian.org>  Mon, 23 Jan 2023 16:04:06 -0500

irony-mode (1.5.0-4) unstable; urgency=medium

  * Tighten irony-server dependency to guard against the possibility of
    mismatched versions.
  * Add 0002-Drop-info-which-may-confuse-users-from-README.patch which does
    exactly what it sounds like it does.
  * Update my copyright years.
  * Declare Standards-Version 4.6.1 (no changes required).

 -- Nicholas D Steeves <sten@debian.org>  Fri, 02 Sep 2022 15:56:18 -0400

irony-mode (1.5.0-3) unstable; urgency=medium

  * Switch to llvm-toolchain-14, and build with libclang-14-dev, clang-14,
    and llvm-14-dev.

 -- Nicholas D Steeves <sten@debian.org>  Fri, 08 Apr 2022 21:45:06 -0400

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: irony-mode
 Section: editors
 Priority: optional
-Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
 Uploaders: Nicholas D Steeves <sten@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- libclang-13-dev,
- clang-13,
- llvm-13-dev,
+ libclang-16-dev,
+ clang-16,
+ llvm-16-dev,
  dh-elpa,
  python3-docutils
 Rules-Requires-Root: no
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/Sarcasm/irony-mode/
 Vcs-Git: https://salsa.debian.org/emacsen-team/irony-mode.git
 Vcs-Browser: https://salsa.debian.org/emacsen-team/irony-mode
@@ -23,7 +24,7 @@
 Depends:
  ${elpa:Depends},
  ${misc:Depends},
- irony-server
+ irony-server (>=${source:Version})
 Breaks: irony-mode (<< 1.4.0-2~)
 Replaces: irony-mode (<< 1.4.0-2~)
 Provides: irony-mode

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Dserver --with elpa

override_dh_elpa:
	sed -i "/:package-version/s/1.2.0/$(DEB_VERSION_UPSTREAM)/" irony.el
	sed -i "s/1.2.0/$(DEB_VERSION_UPSTREAM)/" irony-server.rst
	dh_elpa
	sed -i "s/$(DEB_VERSION_UPSTREAM)/1.2.0/" irony-server.rst
	sed -i "/:package-version/s/$(DEB_VERSION_UPSTREAM)/1.2.0/" irony.el

override_dh_installman:
	mkdir -p debian/tmp
	rst2man irony-server.rst > debian/tmp/irony-server.man
	dh_installman

## irony-mode 1.6.1

=== server/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,19 +1,45 @@
-include(CheckClangResourceDir)
+# XXX: if there are issues
+# due to https://reviews.llvm.org/D30911 / SVN Revision 298424
+# then use the fallback when LLVM_VERSION VERSION_LESS 5.0.1
+find_package(Clang)
 
-find_package(LibClang REQUIRED)
+if (Clang_FOUND)
+  # XXX: at least since Clang 8.0.0
+  # it's looks like the 'libclang' IMPORTED target
+  # does not specify the following target property:
+  #     INTERFACE_INCLUDE_DIRECTORIES ${CLANG_INCLUDE_DIRS}
+  # which is confirmed by https://github.com/Sarcasm/irony-mode/issues/530
+  # so we work around this,
+  # but ideally Clang upstream should export fully usable IMPORTED targets
+  add_library(irony_libclang INTERFACE)
+  target_link_libraries(irony_libclang INTERFACE libclang)
+  target_include_directories(irony_libclang INTERFACE ${CLANG_INCLUDE_DIRS})
 
-include_directories(${LIBCLANG_INCLUDE_DIRS})
-include_directories(${CMAKE_CURRENT_SOURCE_DIR})
-
-check_clang_resource_dir()
-
-if (CLANG_RESOURCE_DIR)
-  # look for CLANG_BUILTIN_HEADERS_DIR usage in the code for an explanation
-  add_definitions(-DCLANG_RESOURCE_DIR=\"${CLANG_RESOURCE_DIR}\")
+  get_property(IRONY_CLANG_EXECUTABLE TARGET clang PROPERTY LOCATION)
+  execute_process(
+    COMMAND "${IRONY_CLANG_EXECUTABLE}" -print-resource-dir
+    OUTPUT_VARIABLE CLANG_RESOURCE_DIR
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+  )
+else()
+  # fallback to historically FindLibClang.cmake
+  # and -resource-dir guess mecanism
+  include(CheckClangResourceDir)
+  find_package(LibClang REQUIRED)
+  check_clang_resource_dir()
 endif()
 
 # not to be taken as a module-definition file to link on Windows
 set_source_files_properties(Commands.def PROPERTIES HEADER_FILE_ONLY TRUE)
+
+if(MSVC)
+  # irony-server uses some code that breaks when iterator debugging is enabled
+  #
+  # The culprit is CommandLineArgumentParser who initialize its member
+  # 'Position', of type 'std::string::const_iterator', to 'Input.begin() - 1'.
+  # With checked iterator the begin() - 1 breaks in debug build.
+  add_definitions(/D_ITERATOR_DEBUG_LEVEL=0)
+endif()
 
 add_executable(irony-server
   support/CommandLineParser.cpp
@@ -27,12 +53,18 @@
   Command.cpp
   Commands.def
   Command.h
+  CompDBCache.h
+  CompDBCache.cpp
   Irony.cpp
   Irony.h
   TUManager.cpp
   TUManager.h
 
   main.cpp)
+
+irony_target_set_cxx_standard(irony-server)
+
+target_include_directories(irony-server PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
 
 # retrieve the package version from irony.el
 function(irony_find_package_version OUTPUT_VAR)
@@ -64,6 +96,16 @@
   PROPERTIES
   COMPILE_DEFINITIONS IRONY_PACKAGE_VERSION=\"${IRONY_PACKAGE_VERSION}\")
 
-target_link_libraries(irony-server ${LIBCLANG_LIBRARIES})
+if (CLANG_RESOURCE_DIR)
+  # look for CLANG_RESOURCE_DIR_DIR usage in the code for an explanation
+  set_source_files_properties(TUManager.cpp
+    PROPERTIES
+    COMPILE_DEFINITIONS CLANG_RESOURCE_DIR=\"${CLANG_RESOURCE_DIR}\")
+endif()
 
-install(TARGETS irony-server DESTINATION bin)
+target_link_libraries(irony-server irony_libclang)
+
+set_target_properties(irony-server
+  PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
+
+install(TARGETS irony-server DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
irony-mode (1.6.1-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Migrate to llvm-toolchain-19 (Closes: #1081242)

 -- Nicholas D Steeves <sten@debian.org>  Wed, 11 Sep 2024 06:36:55 -0400

irony-mode (1.6.0-4) unstable; urgency=medium

  * Orphan package.

 -- Nicholas D Steeves <sten@debian.org>  Sat, 03 Aug 2024 19:53:10 -0400

irony-mode (1.6.0-3) unstable; urgency=medium

  * Team upload.
  * Rebuild against dh-elpa 2.1.5.
    Upload pushed to dgit-repos but not salsa.
    See <https://lists.debian.org/debian-emacsen/2024/07/msg00077.html>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 25 Jul 2024 22:22:49 +0900

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: irony-mode
 Section: editors
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Emacsen team <debian-emacsen@lists.debian.org>
-Uploaders: Nicholas D Steeves <sten@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- libclang-16-dev,
- clang-16,
- llvm-16-dev,
+ libclang-19-dev,
+ clang-19,
+ llvm-19-dev,
  dh-elpa,
  python3-docutils
 Rules-Requires-Root: no
